diff --git a/sway/config/output.c b/sway/config/output.c
index 713cd2191c..cedc4402f3 100644
--- a/sway/config/output.c
+++ b/sway/config/output.c
@@ -390,6 +390,16 @@ static void queue_output_config(struct output_config *oc,
 	}
 }
 
+static void reconfigure_all_devices(void) {
+	struct sway_input_device *input_device = NULL;
+	wl_list_for_each(input_device, &server.input->devices, link) {
+		struct sway_seat *seat = NULL;
+		wl_list_for_each(seat, &server.input->seats, link) {
+			seat_configure_device(seat, input_device);
+		}
+	}
+}
+
 bool apply_output_config(struct output_config *oc, struct sway_output *output) {
 	if (output == root->noop_output) {
 		return false;
@@ -426,6 +436,9 @@ bool apply_output_config(struct output_config *oc, struct sway_output *output) {
 	}
 
 	if (oc && !oc->enabled) {
+		// Reconfigure all devices, since some config items (like map_to_output)
+		// are dependent on a specific output being online.
+		reconfigure_all_devices();
 		return true;
 	}
 
@@ -478,17 +491,7 @@ bool apply_output_config(struct output_config *oc, struct sway_output *output) {
 		output->max_render_time = oc->max_render_time;
 	}
 
-	// Reconfigure all devices, since input config may have been applied before
-	// this output came online, and some config items (like map_to_output) are
-	// dependent on an output being present.
-	struct sway_input_device *input_device = NULL;
-	wl_list_for_each(input_device, &server.input->devices, link) {
-		struct sway_seat *seat = NULL;
-		wl_list_for_each(seat, &server.input->seats, link) {
-			seat_configure_device(seat, input_device);
-		}
-	}
-
+	reconfigure_all_devices();
 	return true;
 }
 
diff --git a/sway/input/libinput.c b/sway/input/libinput.c
index caaba5a193..4ec7288212 100644
--- a/sway/input/libinput.c
+++ b/sway/input/libinput.c
@@ -4,6 +4,7 @@
 #include <wlr/backend/libinput.h>
 #include "log.h"
 #include "sway/config.h"
+#include "sway/output.h"
 #include "sway/input/input-manager.h"
 #include "sway/ipc-server.h"
 
@@ -190,9 +191,24 @@ static bool config_libinput_pointer(struct libinput_device *device,
 	sway_log(SWAY_DEBUG, "config_libinput_pointer('%s' on  '%s')",
 			ic->identifier, device_id);
 	bool changed = false;
-	if (ic->send_events != INT_MIN) {
+
+	if (ic->mapped_to_output &&
+			!output_by_name_or_id(ic->mapped_to_output)) {
+		sway_log(SWAY_DEBUG,
+				"Pointer '%s' is mapped to offline output '%s'; disabling input",
+				ic->identifier, ic->mapped_to_output);
+		changed |= set_send_events(device,
+			LIBINPUT_CONFIG_SEND_EVENTS_DISABLED);
+	} else if (ic->send_events != INT_MIN) {
 		changed |= set_send_events(device, ic->send_events);
+	} else {
+		// Have to reset to the default mode here, otherwise if ic->send_events
+		// is unset and a mapped output just came online after being disabled,
+		// we'd remain stuck sending no events.
+		changed |= set_send_events(device,
+			libinput_device_config_send_events_get_default_mode(device));
 	}
+
 	if (ic->tap != INT_MIN) {
 		changed |= set_tap(device, ic->tap);
 	}
diff --git a/sway/input/seat.c b/sway/input/seat.c
index 1be8d5527b..01e9227fef 100644
--- a/sway/input/seat.c
+++ b/sway/input/seat.c
@@ -19,6 +19,7 @@
 #include "sway/input/cursor.h"
 #include "sway/input/input-manager.h"
 #include "sway/input/keyboard.h"
+#include <sway/input/libinput.h>
 #include "sway/input/seat.h"
 #include "sway/input/switch.h"
 #include "sway/input/tablet.h"
@@ -764,6 +765,8 @@ void seat_configure_device(struct sway_seat *seat,
 		return;
 	}
 
+	sway_input_configure_libinput_device(input_device);
+
 	switch (input_device->wlr_device->type) {
 		case WLR_INPUT_DEVICE_POINTER:
 			seat_configure_pointer(seat, seat_device);
